#ifndef _VERSION_H_
#define _VERSION_H_

/*    ******************************************************************
                     VERSION.H - Version Control File
 *    ******************************************************************      *
 ******************************************************************************
 ******************************************************************************
 **                           WOLF4SDL (c)2008                               **
 ******************************************************************************
 ******************************************************************************
 **                                                                          **
 **                                                                          **
 **    Wolf4SDL by Moritz "Ripper" Kroll (http://www.chaos-software.de.vu)   **    
 **                                                                          ** 
 **                                                                          **
 **  Wolf4SDL is an open-source port of id Software's classic first-person   **
 **  shooter Wolfenstein 3D to the cross-plattform multimedia library        **
 **  "Simple DirectMedia Layer (SDL)" (http://www.libsdl.org).               **
 **  It is meant to keep the original feel while taking advantage of some    **
 **  improvements from the library and allow Wolfenstein to run on many      **
 **  platforms - Including Win98/SE, WinME, Win2K, WinXP, Windows Vista      **
 **  (32 and 64 bit), Linux, BSD variants, KallistiOS (used for Dreamcast)   **
 **  Only little endian platforms like x86, ARM and SH-4 are supported, yet. **
 **                                                                          **
 **                                                                          **
 ******************************************************************************

 ******************************************************************************

   Below you will find different options that you can enable and disable to
   make the source code suit your needs.  Great time and effort has been put
   into this source by many people who have contributed source code and
   routines, to give the original source more features than the original
   release source code - released by Id Software (c)1992 - ever had.

   In the documents directory you will find the GPL license under which this
   source code was released.  I suggest highly that you read it and another
   specific file named "TakeNote.txt".  It will give you greater insight into
   how and what you can do with the source.

   If you are just wishing to create your own game by modifying game values,
   you will find them all in the file "wl_gamesettings.h"

 ******************************************************************************

   ==================
      Disclaimer                                                March 9, 2008
   ==================

  By using this software you hereby agree that, ANY and ALL contributors to
  this source code are NOT Responsible for any changes you make to the code
  (ie: You break it -> You are on your own). Furthermore, you agree that
  said contributors to this source, will NOT be held liable for any damages
  to your system or the data contained within your system. In other words:
  This is a delicate source, so please take care in editing!  Also, Remember
  to make backups of your source and data regularly!

  Below you will find a list of defines that can be uncommented to change
  the game in many ways, along with the names of the people who created
  (Contributed) them.  
  
  BrotherTank has installed and tested them all within this source.

  PLEASE REMEMBER: When you release your game to the general public, you
                   MUST give the Contributers to this source credit for
                   any of the work that you enable below (including Id
                   Software for the original source code) - Just as I
                   have done in this file!!


   Wolf3d Source (c)1992 Id Software
   Wolf4SDL (c)2008 Moritz "Ripper" Kroll
   DieHard Forum Source - 2008+ By BrotherTank
 
 ******************************************************************************/


#ifndef VERSIONALREADYCHOSEN              // used for batch compiling
/* ==========================================================================
         Versions - Select the 1 version that you would like to build
   ========================================================================== */
//#define SODV10          // - Spear of Destiny V1.0
//#define SODV14F         // - Spear of Destiny V1.4 Formgen
//#define SODV14FC        // - Spear of Destiny V1.4 Formgen - CopyProtection Enabled
//#define SODV14          // - Spear of Destiny V1.4 Activision/Id
//#define SODDEMO         // - Spear of Destiny Demo
//#define WOLF3DSV10      // - Wolf3d Shareware V1.0 Apogee
//#define WOLF3DSV11      // - Wolf3d Shareware V1.1 Apogee
//#define WOLF3DSV12      // - Wolf3d Shareware V1.2 Apogee
//#define WOLF3DSV14      // - Wolf3d Shareware V1.4 Apogee
//#define WOLF3DV11AP     // - Wolf3d Full V1.1 Apogee
#define WOLF3DV14AP     // - Wolf3d Full V1.4 Apogee
//#define WOLF3DV14AC     // - Wolf3d Full V1.4 Activision
//#define WOLF3DV14ID     // - Wolf3d Full V1.4 Id Software
//#define WOLF3DV14GT     // - Wolf3d Full V1.4 GT

/* ==========================================================================
     Palettes - Select the 1 Palette that you wish to use for your graphics
   ========================================================================== */
//#define SPEARPAL        // - Spear of Destiny Palette
//#define CORR7PAL        // - Corridor 7 Palette
//#define BLAKEPAL        // - Blake Stone Palette
//#define NOAHPAL         // - Noah's Ark Palette
//#define BODYPAL         // - Operation BodyCount Palette
//#define ROTTPAL					// - Rise of the Triad Palette
//#define MACPAL					// - Mac Wolfenstein Palette
//#define NIGHTMPAL				// - Nightmare 3d Palette
//#define DOOMPAL         // - Doom Palette
//#define QUAKEPAL        // - Quake Palette
//#define EODPAL          // - End of Destiny & Spear Resurrection Palette (AreYeP & MCS)
//#define ORBPAL					// - Orb of  (Adam Biser's Palette)
//#define TOSPAL					// -
#define TRICOBPAL				// -	
//#define WOLFPAL         // - Wolfenstein 3d Palette (Default)

// Enable these lines for Internal files - Disable for External Files                          
#define INTERNALDEMOS   // Enables INTERNAL Demos
#define INTERNALREADT   // Enables INTERNAL Readthis/End Text Screens
                        // If your Chosen Version supports Readthis/End Text
#endif

#define ANIMOBJECTS         // Enables animated objects
#define DONT_SIT            // No stationary dogs

#define WOLFDX              // WolfDX palette and two-part title screen

#define HIRESFIX            // Use corrections in 640x480/320x240 mode
//#define NOGETPSYLINE       // No colored line in "Get Psyched!" window
//#define WALLSOUNDS          // Use wall-related Adlib sounds
#define EXTRADOORS          // 4 locked door colors and 2 new doors
#define NOPUSHABLEPATCHES   // Remove compile error w/wall patches

#define FIXACTORDISTANCE     // Prevent actors from barring player to nearby square on map

#define FIX3D		// Fix errors with Dir3D sprites

#ifdef USE_HIRES
       #define HIRES_GUNFIX // Fix gun's accuracy in 128x128
#endif

#define FFTHIRD             // Use 3rd Plane Feature Flags
#define READMUSIC           // Map square (63,63) 3rd Plane for tunes
#define FIXLEAKS            // Fix leaking ceilings?
//#define NEWGUNCODE          // Make gun move before ammo message appears
//#define ENEMYCOORDS         // Enemy coordinates code (Tab+F)

#define ADJUSTXY              // Calculate "center" for various graphics resolutions

#define DARREN              // Dirty Darren statetypes
#define NOSIGNON            // Disable sign-on screen
#define RLAUNCHERSTUFF      // Enable Rocket Launcher code
#define FLOORCEILINGFIX     // Fix "cracks" in floor/ceiling textures

#define RNDFIX              // Fix repeating SFX in ambience

#define WDXPARTIMES         // Change par times to
                            // those for WolfDX maps
                            // (E1/L1 to E1/L3)

//#define USERATS             // Ambient rats feature
#define WOLFDXDEMO          // Compile 3-level demo version
#define FFDATAFIX           // ffData bugfix w/save & load games

#define BLEEDINGENEMIES     // Show blood on enemies when shot


#define ENEMYNULLFIX        // Fix "PlayerDied"
                            // when killerobj = NULL

#define NEWGUNCODE          // always move gun on Fire button
#define DIRECTIONALACTORS   // 3D-Directional Actors code

#define FFTWOPARTS            // Split Feature Flags into two 8-bit values
#define SHADETWOHALVES        // Outdoor shading independent of indoor

#define FASTERDOORS         // Faster doors in WolfDX mode
#define FASTERPWALLS        // Faster Pushwalls in WolfDX mode

#define BJDOOMSTYLE         // BJ moves/runs Doom-style
#define BJSTRAFEDOOM        // BJ moves/runs Doom-style

#ifdef WOLFDXDEMO
#define SKIPDEMOS           // Skip self-running demos
#endif

/* ------------------------------------------------------------------------------------
                 Different Program Modifications & Installed Tutorials 
								    REMOVE the // Commment lines to enable the item
	 ------------------------------------------------------------------------------------ 
   Pre-Installed Tutorials - Use Map Modifiers when Map Making - Use as you wish
   Frozen Bosses              -- Mcs's Bosses will always face the player fix
   Tile Mirror                -- Ripper's Modifier that allows wall tiles to be Mirrored
   Guard Block                -- MCS's Modifier that allows you to Block Guards Movement
   64+ Walls                  -- BrotherTank's 64+ Wall Tiles (Allows 90 walls to be used)
                                 Includes Chris's fix to allow Pushwalls to be any of the
                                 90 wall tiles as well. Enable or Disable by changing the
                                 MAXWALLTILES value in wl_gamesettings.h  -- Set it to 90
                                 if you want to use more than 64 wall graphics.
  
   ------------------------------------------------------------------------------------ */
//
#define USE_FEATUREFLAGS      // Enables Ripper's "the level feature flags" (see bottom of wl_def.h)
#define USE_SHADING           // Enables shading support (see wl_shade.cpp)
#define USE_DIR3DSPR          // Enables Ripper's directional 3d sprites (see wl_dir3dspr.cpp)
#define USE_FLOORCEILINGTEX   // Enables Darkone's floor and ceiling textures stored in the third mapplane (see wl_floorceiling.cpp)
#define USE_HIRES             // Enables Ripper's high resolution textures/sprites (128x128)
#define USE_PARALLAX 16       // Enables parallax sky with 16 textures per sky (see wl_parallax.cpp)
#define USE_CLOUDSKY          // Enables Ripper's cloud sky support (see wl_cloudsky.cpp)
#define USE_STARSKY           // Enables Ripper's star sky support (see wl_atmos.cpp)
#define USE_RAIN              // Enables Ripper's rain support (see wl_atmos.cpp)
#define USE_SNOW              // Enables Ripper's snow support (see wl_atmos.cpp)
//#define PLAYDEMOLIKEORIGINAL  // When playing or recording demos, several bug fixes do not take
                                // effect to let the original demos work as in the original Wolf3D v1.4
                                // (actually better, as the second demo rarely worked)

//#define REMOVEPG13            // Enable Chris's Remove PG13 Screen Tutorial
//#define REMOVESIGNON          // Enable Chris's Remove the Signon Screen
//#define REMOVENONSHARE        // Enable Chris's Remove the Non-Shareware Screen
//#define KILLQUICKRESPAWN      // Enable Chris's Different Respawn Behind You Tutorial
//#define SPLITHITLERMOD        // Enable Adam Biser's Split Hilter Mod (New Object Define = 228)
//#define FAKEHITLEROPENDOORS   // Enable Adam Biser's Fake Hitler can Open Doors Tutorial
//#define ENEMYATTACKSTRENGTH   // Enable BrotherTank's Change Enemy Attack Strength Tutorial
//#define MAPCONTROLPARTIME     // Enable BrotherTank's Control Maps Par Time via Map 
//                                 (top row 61 = Minutes & 62 = seconds) using wall tiles
//                                 place the wall value in the minutes for the minutes you
//                                 want and for the seconds use Wall 1=15secs  2=30 and 3=45
//                                 and of course 0 = no seconds so an even minute.  Defaults
//                                 to a minimum of 2 mins per map if you use lower than wall 2
//                                 in the top row of the map at index 61.  
//#define KILLSDISPLAY          // KyleRTCW's show # of Kills on Statusbar
//#define DARKONEAI             // Darkone's Modified AI Routines - Guards Act/React more Natural
//#define AIRANDOMNESS          // Mod for DARKONEAI - Add's a Little more Randomness
//#define PLUSMINUSIZE          // MCS's Plus and Minus Keys Change Window Size
//#define TEKZOOMSHOCK          // TekZk's Boom/Zoom/Shock Block Mod
//#define KEYSFLOAT             // BrotherTank's Floating Keys - No Graphic Mods Required!
//#define CHRISAUTOMAP          // Chris's Draw an AutoMap in the Statusbar Weapon Location
//#define CHRISAUTOMAP2         // Chris's Mod to his Automap to show only visable areas
//#define CHRISAUTOMAPTEK       // TekZk's Mod to Chris's CHRISAUTOMAP - Show where walked
#define GAMERATIOS            // MCS's display ingame Level Ratios Mod
//#define KNIFEKILL             // Dugtrio17's Kill actor if attacked from behind with knife
//#define STATBARCLOCK          // BrotherTank's Clock on the Statusbar Mod

#define CROSSHAIR             // Crosshair Aiming on screen 
//
// --------- Tutorials that Require Additions to Sprites or Walls ---------------------
//
//#define BOHURTITEM            // Chris's Adding an Item that Hurts the Player when Touched
#define KEYS4                 // Enables 4 Keys on Statusbar
#define DIFFDOORSIDES         // Enable Ripper's Different Door Sides Tutorial 
//#define BLAKESTYLEDOOR        // Enable Adam Biser's Blake Style Doors
#define WALLPATCHES           // Enable Adam Biser's Wall Patches Mod
#define DARKANIMATION         // Darkone's Sprite Animation Mod
//#define FLOATANIMATION        // Adam Biser's Sprite Floating Animation Mod
//#define ANIMATEDWALLS       // Darkone's Animated Walls Mod


// ----------- Wolfenstein Debug Mode Options -----------------------------------------

#define DEBUGKEYS             // Comment this out to compile without the Tab debug keys



/******************************************************************************/
/******************************************************************************/
/*******      Wolfenstein 3d Original Source (c)1992 Id Software        *******/
/******************************************************************************/
/******************************************************************************/
/**                                                                          **/
/**  Distributed under the Limited Use License Agreement - The DieHard       **/
/**  community has collected and contributed to the functionality of this    **/
/**  source.  We have given it options and items that were not available in  **/
/**  any of the Id Software releases, as well as programming other options   **/
/**  that appeared in the games, but not in the source code released.        **/
/**  Please make sure that you READ the License.doc file included within!    **/
/**                                                                          **/
/******************************************************************************/


/* ====================================================================================
       DO NOT PLAY WITH THE LINES BELOW UNLESS YOU REALLY KNOW WHAT YOU ARE DOING!!!
			   BASED ON YOUR SELECTIONS ABOVE, THESE LINES AUTO MODIFY THE VERSION SETUP
	 ==================================================================================== */
#ifndef VERSIONALREADYCHOSEN
 #define CARMACIZED
 #ifdef SODDEMO
  #define SPEAR
  #define SPEARDEMO
 #else
	#ifdef SODV10
		#define SPEAR
		#define GOODTIMES
	#else    
		#ifdef SODV14F 
			#define SPEAR 
			#define GOODTIMES
		#else
			#ifdef SODV14FC		
				#define SPEAR 
			#else
				#ifdef SODV14   
					#define SPEAR 
					#define GOODTIMES
				#else  // Wolfenstein Versions
          #ifdef SEAMLESS 
            #define MAPCONTROLPARTIME    
          #endif

					#ifdef WOLF3DSV10		
						#define UPLOAD
						#define APOGEE_1_0
						#ifdef CARMACIZED
							#undef CARMACIZED
						#endif
						#define SIGNON10
					#else			
						#ifdef WOLF3DSV11		
							#define UPLOAD
							#define APOGEE_1_1
							#define SIGNON11
						#else
							#ifdef WOLF3DSV12 						
								#define UPLOAD
								#define APOGEE_1_2
								#define SIGNON11
							#else
								#ifdef WOLF3DSV14		
									#define UPLOAD
									#define SIGNON14AP
								#else
									#ifdef WOLF3DV11AP		
										#define APOGEE_1_1
										#define SIGNON11
									#else
										#ifdef WOLF3DV14AP		
											#define SIGNON14AP
										#else
											#ifdef WOLF3DV14AC		
												#define GOODTIMES	
												#define SIGNON14AC
											#else
												#ifdef WOLF3DV14ID		
													#define GOODTIMES
													#define SIGNON14ID
												#else
													#ifdef WOLF3DV14GT		
														#define GOODTIMES
														#define SIGNON14GT
													#endif		
												#endif
											#endif		
										#endif		
									#endif		
								#endif		
							#endif		
						#endif	
					#endif	
				#endif	
			#endif	
		#endif
	#endif
 #endif

 #ifdef INTERNALDEMOS
  #define DEMOSEXTERN     // Enables internal Game Demo Files
 #endif
 #ifdef INTERNALREADT
  #define ARTSEXTERN      // Enables internal Endgame/Readthis Screens
 #endif

//#define SIGNON14IM  // Japanese Version Signon
//#define DARKSIGNON  // Darkones Signon Screen
//#define SIGNONBETA  // Beta Version Signon
#endif // Ifndef Versionalreadychosen

#ifdef CHRISAUTOMAPTEK
  #ifdef CHRISAUTOMAP
    #undef CHRISAUTOMAP
  #endif
#else
  #ifdef CHRISAUTOMAP2
    #define CHRISAUTOMAP
  #endif
#endif          

#ifdef RAYCASTOR // Items NOT Required when using the Raycastor Code
  #ifdef BLAKESTYLEDOOR
    #undef BLAKESTYLEDOOR
  #endif
  #ifdef USE_DIR3DSPR
    #undef USE_DIR3DSPR
  #endif


#endif // Raycastor
#endif // _Version_
