/* ==================================================================
                      wl_set.h - Source Code Values
   ==================================================================
    You may modify and change the values within this file and as
    long as you don't go crazy, you probably won't break the code.
    That doesn't mean that the code source doesn't have limits.
    The biggest limitation to the source is the amount of data that
    the program can handle.

	  So modify, play and enjoy, but be careful - BrotherTank
   ================================================================== */

// File Names
#define HINTFILENAME          "hintep?." // Use Hint Bubble filenames
#define DEMOFILENAME          "demo?."    // Using External Demo files - This is the filename
#define VGAHEADFILENAME     "vgahead."    // VGAGraph index file 
#define VGAGRAPHFILENAME   "vgagraph."    // The actual Vga Graphics for the game
#define VGADICTFILENAME     "vgadict."    // The VGAGraph Compression Dictionary
#define MAPHEADFILENAME     "maphead."    // The Map File index file
#define MAPTEMPFILENAME     "maptemp."    // Version 1.0 & Alpha Map Filename  
#define MAPSFILENAME       "gamemaps."    // Version 1.1 & Higher Map Filename
#define AUDIOHEDFILENAME   "audiohed."    // The Audio File index file
#define AUDIOTFILENAME       "audiot."    // The Audio File - music
#define SAVEFILENAME       "savegam?."    // The name the saved games will use
// If using External Help/Endard Screens
#define HELPFILENAME        "helpart."    // External Help Screen file name 
#define ENDFILENAME         "endart1."    // External Endart Screen file name

// Defines for using your own Game File Extension
//#define MYGAMENAME      "WOLFSPEAR 3D"
//#define MYGAMEEXTENSION          "WS6"
//#define NUMEPISODES                 6

#ifdef SPEAR
  #define NUMMAPS                    21     // Number of Maps in your Game  
#else
  #define NUMMAPS                    60     // Number of Maps in your Game  
#endif
//#define NUMAPLANES                  3     // Number of Map Planes You Need 
                                          // Only enable if you need more than
                                          // 2 and/or aren't using USE_FLOORCEILINGTEX   

#define MAXACTORS									500    // max number of nazis, etc / map
#define MAXSTATS									2000   // max number of lamps, bonus, etc
#define MAXDOORS									64     // max number of sliding doors
#define MAXWALLTILES							    90     // max number of wall tiles

#define MAXVISABLE                500			// Sprites visible in any one view 

#ifdef SPEAR
  #define DEBUGPARAMETER  "--debugmode"     // Spear of Destiny Debug Mode Enable Parameter
#else
  #define DEBUGPARAMETER    "--goobers"     // Wolfenstein Debug Mode Enable Parameter
#endif

#define MENUSONG         WONDERIN_MUS     // Music to Play at Menus
#ifdef SPEAR
  #define INTROSONG       XTOWER2_MUS     // Spear Game Intro Music
#else
  #define INTROSONG      NAZI_NOR_MUS     // Wolfenstein Game Intro Music
#endif

// Player Starting Amounts/Values/Points
#define STARTAMMO										8			// Starting Ammo for the Player
#define STARTAMMO2										0			// Starting Ammo for the Player
#define STARTWEAPON         wp_pistol     // Starting Weapon for the Player
#define AMMOWEAPON                  6     // Ammo for picking up a weapon
#define AMMOCLIP                    8     // Ammo for picking up a Full Ammo Clip
#define AMMOCLIPUSED                4     // Ammo for picking up a Used Ammo Clip
#define AMMOCLIP25                 25     // Ammo for AmmoBox Pickup (Spear code only)
#define AMMOFULLHEAL               25     // Ammo for picking up FullHeal/ExtraMan Orb
#define AMMOMAX                    99     // Maximum Amount of Ammo that the player can carry
#define HEALTHAID                  25     // Health points for First Aid Kit
#define HEALTHFOOD                 10     // Health points for Food Plate
#define HEALTHALPO                  4     // Health points for Dog Food
#define HEALTHGIBS                  1     // Health points for each Blood (Gibs) puddle
#define HEALTHGIBSSTOP             10     // Maximum Limit when player can no longer drink gibs
#define MAXHEALTH                 100     // Maximum Health a player can reach 
#define MAXLIVES                    9     // Maximum number of lives 
#define EXTRAPOINTS							40000			// Points required for each additional 1up/Man
#define BONUSPOINT1               100     // Points for picking up Cross
#define BONUSPOINT2               500     // Points for picking up Chalice
#define BONUSPOINT3              1000     // Points for picking up Box of Jewels/Bible 
#define BONUSPOINT4              5000     // Points for picking up Crown

// Common Enemies
#define KILLGUARDPOINTS           100     // Points for killing each Guard
#define KILLOFFICERPOINTS         400     // Points for killing each Officer
#define KILLMUTANTPOINTS          700     // Points for killing each Mutant
#define KILLSSPOINTS              500     // Points for killing each SS
#define KILLDOGPOINTS             200     // Points for killing each Dog

// Wolfenstein Enemies Points
#define KILLHANSPOINTS           5000     // Points for killing each Boss Hans
#define KILLGRETELPOINTS         5000     // Points for killing each Boss Gretel
#define KILLGIFTMACHERPOINTS     5000     // Points for killing each Boss Giftmacher
#define KILLFATFACEPOINTS        5000     // Points for killing each Boss FatFace
#define KILLSCHABBSPOINTS        5000     // Points for killing each Boss Schabbs
#define KILLFAKEHITLERPOINTS     2000     // Points for killing each Fake Hitler (Ghost)
#define KILLMECHAHITLERPOINTS    5000     // Points for killing each Mechanized Hitler
#define KILLHITLERPOINTS         5000     // Points for killing each Boss Real Hitler

// Spear Enemies Points
#define KILLSPECTREPOINTS         200     // Points for killing each Spectre (Ghost)
#define KILLANGELPOINTS          5000     // Points for killing each Boss Angel
#define KILLTRANSPOINTS          5000     // Points for killing each Boss Trans Grosse
#define KILLUBERMUTANTPOINTS     5000     // Points for killing each Boss Uber Mutant
#define KILLWILLPOINTS           5000     // Points for killing each Boss Submarine Willy
#define KILLDEATHPOINTS          5000     // Points for killing each Boss Death Angel

// Spear of Destiny Secret Level Defines
#define FROMSECRET1                 3     // Location of Secret Elevator #1 to goto TOSECRET1
#define FROMSECRET2                11     // Location of Secret Elevator #2 to goto TOSECRET2
#define TOSECRET1                  18     // Location of SoD First Secret Level
#define TOSECRET2                  19     // Location of SoD Second Secret Level
#define SPEARLASTSHOWLEVEL         18     // When on SPEARLASTLEVEL display this Level Number
#define SPEARLASTLEVEL             20     // This is the Warped Level (Last Level) of Spear Game
#define SPEARDAMAGEBUGEYE          30     // This is the hurt point value at which BJ's eye will Bug 

// WL_inter
#define VBLWAIT                    30     //
#define PAR_AMOUNT                500     // Points for Each Second Below Par Time
#define PERCENT100AMT           10000     // Points for Each 100% Ratio (Kills, Secret, Treasure)

#ifdef SPEAR  // Spear of Destiny Colours
  // Signon Amount of Memory Draw Colours
  #define MAINCOLOR                 0x4f  //
  #define EMSCOLOR                  0x4f  //
  #define XMSCOLOR                  0x4f  //
  // Menu Colours - Text and Borders
  #define MenuFadeOut()   VL_FadeOut(0,255,0,0,51,10)  
  #define BORDCOLOR                 0x99  //
  #define BORD2COLOR                0x93  //
  #define DEACTIVE                  0x9b  //
  #define BKGDCOLOR                 0x9d  //
  #define STRIPE                    0x00  // 0x9c
#else  // Wolfenstein Colours 
  // Signon Amount of Memory Draw Colours
  #define MAINCOLOR                 0x6c  //
  #define EMSCOLOR                  0x6c  // 0x4f
  #define XMSCOLOR                  0x6c  // 0x7f
  // Menu Colours - Text and Borders
  #define MenuFadeOut()   VL_FadeOut(0,255,43,0,0,10)
  #define BORDCOLOR                 0x29  //
  #define BORD2COLOR                0x23  //
  #define DEACTIVE                  0x2b  //
  #define BKGDCOLOR                 0x2d  //
  #define STRIPE                    0x2c  //
#endif
// Common Menu Colours to Both Versions
#define FILLCOLOR                  14     //
#define READCOLOR                   0x4a  //
#define READHCOLOR                  0x47  //
#define VIEWCOLOR                   0x7f  //
        #ifndef WOLFDX
                #define TEXTCOLOR       0x17
                #define HIGHLIGHT       0x13
        #else
                #define TEXTCOLOR       0x1d
                #define HIGHLIGHT       0x16
        #endif
#define MenuFadeIn()      VL_FadeIn(0,255,gamepal,10)


#define PLAYERSPEED							 3000			// 
#define RUNSPEED								 6000     // 

        #ifdef BJSTRAFEDOOM
#define BJSUB2SPEED                              8
#define BJSTRAFESPEED                            (BJSUB2SPEED*2)
#define BJMAXSIDESPEED                           (BJSUB2SPEED*5)
#define BJMAXRUNSIDESPEED                        (BJMAXSIDESPEED*2)
        #endif

        #ifdef BJDOOMSTYLE
#define BJSUBSPEED                               8
#define BJWALKSPEED		                         (BJSUBSPEED*2)     // 
#define BJMAXWALKSPEED                           (BJSUBSPEED*5)
#define BJMAXRUNSPEED                            (BJMAXWALKSPEED*2)
        #endif

#define PROJECTILESIZE              0xc000l //
#define PROJSIZE                    0x2000  // 


#define BJSPRITESPEED               2048     // Wolfenstein Game Ending Player Run Speed
#define BJJUMPSPEED               680     // Wolfenstein Game Ending Player Jump Speed


#define BORDERCOLOR									3     //
#define FLASHCOLOR									5     //
#define FLASHTICS										4     //

#define MAXDEMOSIZE              8192     //

#define SCREENMAXSIZE              21
#define SCREENMINSIZE               1
#define STATUSLINES								 40     //

#define BASEMOVE									 35     //
#define RUNMOVE										 70     //
#define BASETURN									 35     //
#define RUNTURN										 70     //
#define JOYSCALE										2     //


#define DOORWIDTH                   0x7800 // 
#define OPENTICS                  300      // Door Open time (70 = 1 Sec) 


#define SPDPATROL									512     //
#define SPDDOG									 1500     //


#define TURNTICS									 10     // Number of Game Tics required for a turn
#define MAXMOUSETURN               10     // Number of Game Tics required for a Mouse turn
#define MOVESCALE                 150l    //
#define BACKMOVESCALE             100l    //
#define ANGLESCALE                 20     //

#define MAXPOINTS                 400     // Max Number of Rain/Snow Drops on Screen

// if you have problems with directional sprites being visible through wall edges
// where they shouldn't, you can try to adjust SIZEADD
//#define SIZEADD                  0        //
#define SIZEADD                  1024     //

//
// The Door Settings in the Game - Adjust Carefully
//
// the doors are the last pictures before the sprites
#define NUMDOORPICS                12  // There are 4 Door Graphics with 2 pics for 
                                       // each type - 1 being light and 1 being dark
                                       // thus 8 graphics but only 4 types 
// Door Graphics (0+4)
#define DRNORM1DOORPIC              6  //  6
#define DRLOCK1DOORPIC              16  //  16
#define DRLOCK2DOORPIC              18  //  18
#define DRLOCK3DOORPIC              20  //  20
#define DRLOCK4DOORPIC              22  //  22
#define DRELEVDOORPIC               10  //  10
#define DRNORM2DOORPIC              12  //  12
#define DRNORM3DOORPIC              14  //  14
// Door Sides -- IF USING DIFFERENTDOORSIDES
#define DRNORM1SIDEPIC              8  //  8
#define DRLOCK1SIDEPIC              0  //  0
#define DRLOCK2SIDEPIC              0  //  0
#define DRLOCK3SIDEPIC              0  //  0
#define DRLOCK4SIDEPIC              0  //  0
#define DRELEVSIDEPIC               0  //  0
#define DRNORM2SIDEPIC              2  //  2
#define DRNORM3SIDEPIC              4  //  4
// Only Works with RAYCASTOR unless you enable BLAKESTYLEDOOR in the Version.h File
// Door Type         0 = Normal Door  1 = Center Opening
#define DRNORM1TYPE                 1  //  0
#define DRLOCK1TYPE                 1  //  0
#define DRLOCK2TYPE                 0  //  0
#define DRLOCK3TYPE                 1  //  0
#define DRLOCK4TYPE                 0  //  0
#define DRELEVTYPE                  1  //  0
#define DRNORM2TYPE                 1  //  0
#define DRNORM3TYPE                 0  //  0

//
#define ACTORSIZE                   0x4000 //

// Special Graphic Identifiers
#define ELEVATORTILE							 21			// Elevator Switch Graphic Position in Vswap

// Map Plane (0) Walls

// Wall Identifiers are:     0 to  89			// Wall Values
// Door Identifiers are:    90 to 105			// Door Types

#define AMBUSHTILE                106     // Ambush/Deaf Enemy Tile
// Floor Indentifiers are: 107 to 144
#define AREATILE                  107     // First of NUMAREAS Floor Tiles
#define NUMAREAS                   45     // Number of Floor Areas
#define ALTELEVATORTILE           107     // Secret Elevator Floor

#define VINESPAWNER               197

// Map Plane (1) Objects
// Direction Arrows are:    90 to 97

#define ICONARROWS                 90     // Path Direction Arrows
#define PUSHABLETILE               98     // Pushwall Identifier
#define EXITTILE                   99     // Trigger End of Game Tile
#define ENDLEVELTILE              509     // MCS's Trigger End of Level Tile
#define CROSSHAIRCOLOUR           7       // Color of cross hair for HUD player weapon
#define BLOCKGUARD1               510     // MCS's Block Enemy tile 1
#define BLOCKGUARD2               511     // MCS's Block Enemy tile 2
#define TILEMIRROR                508     // Ripper's Tile Mirror
#define ANIMTILE                  507     // Darkone's Animated Walls Mod 
                                          // (uses this number + 4) to set the 5 Speeds

#define STARTRAIN                 500     // Event spawn tile 1

#define TELEPORT1A                448     // Teleport;  1A->1B
#define TELEPORT1B                449     //      and vice versa
#define TELEPORT2A                450     // 2A->2B and vice versa
#define TELEPORT2B                451     // ...
#define TELEPORT3A                452
#define TELEPORT3B                453
#define TELEPORT4A                454
#define TELEPORT4B                455

#define TELELADDER1A              456
#define TELELADDER1B              457
#define TELELADDER2A              458
#define TELELADDER2B              459

// When Config.ext is deleted - High Score Reset Values
//
// Ending in A = Name - Must be in Quotes
// Ending in B = Score player achieved
// Ending in C = Episode being Played
//
#define	HIGHSCORE1A  "Tricob"
#define HIGHSCORE1B  10000
#define HIGHSCORE1C  1
#define HIGHSCORE2A  "BT"
#define HIGHSCORE2B  10000
#define HIGHSCORE2C  1
#define HIGHSCORE3A  "RonWolf"
#define HIGHSCORE3B  10000
#define HIGHSCORE3C  1
#define HIGHSCORE4A  "Dean"
#define HIGHSCORE4B  10000
#define HIGHSCORE4C  1
#define	HIGHSCORE5A  "WLHack"
#define HIGHSCORE5B  10000
#define HIGHSCORE5C  1
#define	HIGHSCORE6A  "Ripper"
#define HIGHSCORE6B  10000
#define HIGHSCORE6C  1
#define	HIGHSCORE7A  "Neo-traditions"
#define HIGHSCORE7B  10000
#define HIGHSCORE7C  1


// *******************
// Statusbar Locations
// *******************
//
// X ending = X location on Statusbar
// Y ending = Y location on Statusbar
// D ending = # of digits to Display on Statusbar
//
// Ammunition
#define AMMOX              26 
#define AMMOY              16 
#define AMMOD               3
// Face Pictures
#define FACEPICX           17
#define FACEPICY            4
// Health
#define HEALTHX            21
#define HEALTHY            16
#define HEALTHD             3
// Level
#define LEVELX              2
#define LEVELY             16
#define LEVELD              2
// Lives
#define LIVESX             14
#define LIVESY             16
#define LIVESD              1
// Score
#define SCOREX              6
#define SCOREY             16
#define SCORED              6
// Weapon Graphic
#define WEAPONX            32
#define WEAPONY             8
// KEYS
#define KEY1X              30
#define KEY1Y               4
#define KEY1PIC    GOLDKEYPIC
#define KEY2X              30
#define KEY2Y              20
#define KEY2PIC  SILVERKEYPIC
#define KEY3X              31  
#define KEY3Y               4
#define KEY3PIC    GOLDKEYPIC
#define KEY4X              31 
#define KEY4Y              20
#define KEY4PIC  SILVERKEYPIC



/* --------------------------------------------------------------------------
                   Enabled Tutorials Game Settings and Values
   -------------------------------------------------------------------------- */

// Chris's Quick Respawn Mod
#define KILLQUICKRESPAWNLEVEL      80     // Kill % Level Below KILLQUICKRESPAWN Routine stops Working

// Enemy Attack Strength Mod Values
#define SSATTACKSTRENGTH            1.25  // SS Attack Strength Modifier
#define MISSLEATTACKSTRENGTH        1.8   // GiftMacher/FatFace Rocket Strength Modifier
#define CHAINGUNBOSSATTACKSTRENGTH  1.6   // Trans/Gretel/Mecha/Hitler Attack Strength Modifier 
#define THROWATTACKSTRENGTH         1.4   // Schabbs Attack Strength Modifier
#define PISTOLATTACKSTRENGTH        1     // All other Enemies Attack Strength Modifier

// Kills on Statusbar Mod
#define KILLDISPLAYX               36 
#define KILLDISPLAYY               16
#define KILLDISPLAYD                3

// MCS's Screen Resize
#define ADJSCREENPLUS        sc_Equal
#define ADJSCREENMINUS       sc_Minus

// MCS's Seamless 
// Remember to set the Total Number of Maps (Above at the top of this file) in your game
// including the secret levels - Then set these variables to where you have actually put
// the secret maps in the gamemaps file and the number of secret levels you have.
#define SEAMLESSSTART              50     // Secret Levels start at this point in your
                                          // gamemaps file
#define SEAMLESSSECRET             10     // Number of Seamless Secret Levels


// "Jaws" wall patch values
#define JAWS_EW                    485
#define JAWS_NS                    486

// Wall Patches
#define NUMWALLPATCHPICS           31     // Number of Patch Graphics sets consisting of a
                                          // set of 1 light and 1 dark image - so for every
                                          // 2 images, this number is + 1
                                          // These graphics go between the last wall image
                                          // and the start of the door images
#define FIRSTPATCHIDENTIFIER      460     // This is the number value placed on the map 
                                          // on the Object plane to patch the patch graphic 
                                          // onto the wall image selected on the Map Wall Plane
#define PUSHPATCHIDENTIFIER       960     // As with FIRSTPATCHIDENTIFIER this is the value
                                          // placed on the Object plane to identify a Pushwall
                                          // that is using a Patchwall

//
//  Tab - ???? Key Sequences that toggle or display
//
// Tekzk's Zoom/Boom/Quake
//#define ZOOMEFFECTKEY            sc_Q     // In Game Zoom Toggle
//#define QUAKEEFFECTKEY           sc_E     // Quake Start

// MCS's Level Ratios Mod
#define GAMERATIOSKEY            sc_D     // Display Current Kills/Secrets/Treasure Ratios
